/************************************************************
 *	FILE DESCRIPTION
 *		\f[^Zbg̍sRs[@\
 *              w肳ꂽ͈͂̍s dst s̒ɃRs[
 *	FILE	:	d3tcpr.c
 *		:	d3tcpr
 *			dsp	:	DSET |C^
 *			from	:	Rs[Jnsԍ ( from >= 1 )
 *			to	:	Rs[Isԍ ( to <= s )
 *			dst	:	Rs[sԍ ( 0 <= dst <= s )
 *	REMARKS	:	1988-07-11	M.MOTOKI
 *
 ************************************************************/

#include <stdio.h>

#include <stdio.h>
#include "la_ws/include/d3libc.h"
#include "la_ws/include/d3lmac.h"

extern	char	*d3allc();
extern	DMEM	*d3gcmp(), *d3gtra();
extern	char	*malloc();

static	char	sccsid[]="%Z%%M% %I% %E% %U%";
static	DMEM	*datp, *dimp, *datap;

d3tcpr(dsp, from, to, dst)
DSET	*dsp;
int	from, to, dst;
{
	int	err, rn, cn, memno, nline;

						/* `FbN */
	err = tcpr10(dsp, from, to, dst, &rn, &cn, &datp, &dimp, &datap);
	if (err != 0)
		return(err);

	nline = to - from + 1;
	memno = PD_MEMNO(dsp);
						/* f[^̃Rs[ */
	if ((err = tcpr70(memno, from, dst, rn, cn, nline)) != 0)
		return(err);

	return(0);
}

/****************************************************
*	`FbN[`
****************************************************/
tcpr10(dsp, from, to, dst, rn, cn, datp, dimp, datap)
DSET	*dsp;
int	from, to, dst;
int	*rn, *cn;
DMEM	**datp, **dimp, **datap;
{
	if ((*datp = d3gcmp(PD_DMEM(dsp), "Dat")) == NULL)
		return(DE_DS_FORMAT);

	if ((*datap = d3gcmp(*datp, "Data")) == NULL)
		return(DE_PRM);

	if ((*dimp = d3gcmp(*datp, "Dim")) == NULL)
		return(DE_PRM);

	if (PD_LENGTH(*dimp) != 2)
		return(DE_PRM);

	*rn = *(PD_VALUE(*dimp) + 0);
	*cn = *(PD_VALUE(*dimp) + 1);

	if (1 <= from	&&
		from <= to	&&
		to   <= *rn	&&
		0    <= dst	&&
		dst  <= *rn)
		;			/* OK */
	else
		return(DE_PRM);

	return(0);
}

/****************************************************
*	f[^̃Rs[
****************************************************/
static	tcpr70(memno, from, dst, rn, cn, nline)
int	memno, from, dst, rn, cn, nline;
{
	int	*work, *data, *d, *s, *w;
	int	*p, *q;
	int	i, j, k , size;
	int	*source, *destin;

					/* Dim ̍XV */
	*PD_VALUE(dimp) += nline;
					/* Data ̍XV */

	source = PD_VALUE(datap);	/* IWif[^ւ̃|C^
					   ۑ */

					/* f[^ɋ󂫂邩 */
	size = d3gsiz((rn + nline) * cn);

	if (size != d3gsiz(rn * cn)) {
		if ((data = (int *)d3allc(memno, size * sizeof(int))) == NULL)
			return(DE_MEM);

		PD_VALUE(datap) = data;	/* Vf[^̈ւ̃|C^ */
	}

	destin = PD_VALUE(datap);	/* ]̈ւ̃AhX */

					/* [N̈AP[g */
	if ((work = (int *)malloc(nline * cn * sizeof(int))) == NULL)
		return(DE_MEM);

					/* sf[^[NɃRs[ */
	q = work;
	for (i=1; i<=cn; i++) {
		p = source + rn*(i - 1) + (from - 1);	/* IWif[^ */

		for (j=0; j<nline; j++)
			*q++ = *p++;
	}

				/* [N̍sf[^f[^ɃRs[ */
	s = source + rn * cn;		/* ]AhX */
	d = destin + (rn + nline) * cn;	/* ]AhX */
	w = work + nline * cn;		/* [NAhX */

	for (i=cn; i>0; i--) {

		k = rn - dst;
		for (j=0; j<k; j++)
			*--d = *--s;

		for (j=0; j<nline; j++)
			*--d = *--w;

		k = dst;
		for (j=0; j<k; j++)
			*--d = *--s;
	}

					/* Data ̗vfXV */
	PD_LENGTH(datap) += nline * cn;

	free(work);
	return(0);
}
